/// <reference types="node" />
import EventEmitter from "events";
import { MockRequest } from "../types";
declare type VerboseConfiguration = {
    methods?: string[];
    dismissMocked?: boolean;
    dismissNotMocked?: boolean;
};
declare type Verbose = VerboseConfiguration;
declare type ProviderConstructorArgs = {
    verbose?: boolean | Verbose;
};
export declare class Provider extends EventEmitter {
    requestMocks: Record<string, MockRequest[]>;
    verbose: Verbose;
    constructor({ verbose }: ProviderConstructorArgs);
    request({ method, params, }: {
        method: string;
        params?: unknown[];
    }): Promise<unknown>;
    private findMock;
    private logRequest;
}
export {};
