"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Provider = void 0;
// import { EventEmitter } from "node:events";
var events_1 = __importDefault(require("events"));
var Provider = /** @class */ (function (_super) {
    __extends(Provider, _super);
    function Provider(_a) {
        var verbose = _a.verbose;
        var _this = _super.call(this) || this;
        _this.requestMocks = {};
        _this.verbose =
            verbose === false || verbose === undefined
                ? {
                    methods: [],
                }
                : verbose === true
                    ? {}
                    : verbose;
        return _this;
    }
    Provider.prototype.request = function (_a) {
        var method = _a.method, _b = _a.params, params = _b === void 0 ? [] : _b;
        return __awaiter(this, void 0, void 0, function () {
            var promise, _c, data, callback, returnValue;
            var _this = this;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        promise = new Promise(function (resolve, reject) {
                            var mock = _this.findMock(method, params);
                            if (!mock) {
                                if (!_this.verbose.dismissNotMocked &&
                                    (_this.verbose.methods ? _this.verbose.methods.includes(method) : true)) {
                                    _this.logRequest(method, params, mock);
                                }
                                resolve({ data: undefined });
                                return;
                            }
                            if (!_this.verbose.dismissMocked &&
                                (_this.verbose.methods ? _this.verbose.methods.includes(method) : true)) {
                                _this.logRequest(method, params, mock);
                            }
                            if (!mock.persistent) {
                                _this.requestMocks[method] = _this.requestMocks[method].filter(function (m) { return mock !== m; });
                            }
                            setTimeout(function () {
                                if (mock.shouldThrow) {
                                    reject(mock.data);
                                }
                                else {
                                    resolve({
                                        data: mock.data,
                                        callback: mock.triggerCallback,
                                    });
                                }
                            }, mock.timeout || 0);
                        });
                        return [4 /*yield*/, promise];
                    case 1:
                        _c = _d.sent(), data = _c.data, callback = _c.callback;
                        if (!(typeof data === "function")) return [3 /*break*/, 3];
                        return [4 /*yield*/, data(params)];
                    case 2:
                        returnValue = _d.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        returnValue = data;
                        _d.label = 4;
                    case 4:
                        if (callback) {
                            callback(returnValue, params);
                        }
                        return [2 /*return*/, returnValue];
                }
            });
        });
    };
    Provider.prototype.findMock = function (method, params) {
        var mocks = this.requestMocks[method];
        if (!mocks)
            return null;
        var conditionalMock = mocks.find(function (mock) {
            if (!mock.condition)
                return false;
            return mock.condition(params);
        });
        if (conditionalMock)
            return conditionalMock;
        var standardMock = mocks.find(function (mock) { return !Boolean(mock.condition); });
        return standardMock || null;
    };
    Provider.prototype.logRequest = function (method, params, mock) {
        var mockDescription;
        if (!mock) {
            mockDescription = "No mock has been found. 'undefined' will be resolved.";
        }
        else {
            mockDescription = "\nMock found:\n- Data: ".concat(JSON.stringify(mock.data, null, 4), "\n- Persistent: ").concat(mock.persistent ? "yes" : "no", "\n- Conditional: ").concat(mock.condition ? "yes" : "no", "\n- Should throw: ").concat(mock.shouldThrow ? "yes" : "no", "\n");
        }
        console.log("\n#### [eth-testing] - start log ####\nRequest intercepted: { method: ".concat(method, ", params: ").concat(params ? JSON.stringify(params) : "[]", " }\n").concat(mockDescription, "\n#### [eth-testing] - end log ####\n"));
    };
    return Provider;
}(events_1.default));
exports.Provider = Provider;
